package org.jsflot.components;

import javax.el.ValueExpression;
import javax.faces.component.UIComponent;
import javax.faces.webapp.UIComponentELTag;

public class BubbleDataPointTag extends UIComponentELTag {
	
	private ValueExpression x;
	private ValueExpression y;
	private ValueExpression pointLabel;
	private ValueExpression radius;
	
	@Override
	public String getComponentType() {
		return "org.jsflot.components.BubbleDataPointComponent";
	}

	@Override
	public String getRendererType() {
		return "org.jsflot.components.BubbleDataPointRenderer";
	}

	public ValueExpression getX() {
		return x;
	}

	public void setX(ValueExpression x) {
		this.x = x;
	}

	public ValueExpression getY() {
		return y;
	}

	public void setY(ValueExpression y) {
		this.y = y;
	}

	public ValueExpression getPointLabel() {
		return pointLabel;
	}

	public void setPointLabel(ValueExpression pointLabel) {
		this.pointLabel = pointLabel;
	}
	
	public ValueExpression getRadius() {
		return radius;
	}
	
	public void setRadius(ValueExpression radius) {
		this.radius = radius;
	}
	
	protected void setProperties(UIComponent component) {
		super.setProperties(component);
		component.setValueExpression("x", this.x);
		component.setValueExpression("y", this.y);
		component.setValueExpression("pointLabel", this.pointLabel);
		component.setValueExpression("radius", this.radius);
	}
	
	public void release() {
		super.release();
		
		this.x = null;
		this.y = null;
		this.pointLabel = null;
		this.radius = null;
	}
}
