package org.jsflot.components;

import javax.el.ValueExpression;
import javax.faces.component.UIComponent;
import javax.faces.webapp.UIComponentELTag;

public class XYDataListTag extends UIComponentELTag {

	private ValueExpression showDataPoints;
	private ValueExpression fillLines;
	private ValueExpression showLines;
	private ValueExpression label;
	private ValueExpression markers;
	private ValueExpression markerPosition;
	private ValueExpression color;
	
	@Override
	public String getComponentType() {
		return "org.jsflot.components.XYDataListComponent";
	}

	@Override
	public String getRendererType() {
		return "org.jsflot.components.XYDataListRenderer";
	}

	public ValueExpression getShowDataPoints() {
		return showDataPoints;
	}

	public void setShowDataPoints(ValueExpression showDataPoints) {
		this.showDataPoints = showDataPoints;
	}

	public ValueExpression getFillLines() {
		return fillLines;
	}

	public void setFillLines(ValueExpression fillLines) {
		this.fillLines = fillLines;
	}

	public ValueExpression getShowLines() {
		return showLines;
	}

	public void setShowLines(ValueExpression showLines) {
		this.showLines = showLines;
	}

	public ValueExpression getLabel() {
		return label;
	}

	public void setLabel(ValueExpression label) {
		this.label = label;
	}

	public ValueExpression getMarkers() {
		return markers;
	}

	public void setMarkers(ValueExpression markers) {
		this.markers = markers;
	}

	public ValueExpression getMarkerPosition() {
		return markerPosition;
	}

	public void setMarkerPosition(ValueExpression markerPosition) {
		this.markerPosition = markerPosition;
	}

	public ValueExpression getColor() {
		return color;
	}

	public void setColor(ValueExpression color) {
		this.color = color;
	}

	protected void setProperties(UIComponent component) {
		super.setProperties(component);
		component.setValueExpression("showDataPoints", this.showDataPoints);
		component.setValueExpression("fillLines", this.fillLines);
		component.setValueExpression("showLines", this.showLines);
		component.setValueExpression("label", this.label);
		component.setValueExpression("markers", this.markers);
		component.setValueExpression("markerPosition", this.markerPosition);
		component.setValueExpression("color", this.color);
	}
	
	public void release() {
		super.release();
		
		this.showDataPoints = null;
		this.fillLines = null;
		this.showLines = null;
		this.label = null;
		this.markers = null;
		this.markerPosition = null;
		this.color = null;
	}
}
